#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <time.h>
#include "amcc.h"


dword base_address_0;           /* PCI_CS_BASE_ADDRESS_0 - amcc */
dword base_address_1;           /* PCI_CS_BASE_ADDRESS_1 - memory */
dword base_address_2;           /* PCI_CS_BASE_ADDRESS_2 - pio */
dword base_address_3;           /* PCI_CS_BASE_ADDRESS_3 - cpld */
dword base_address_4;           /* PCI_CS_BASE_ADDRESS_4 - tmr */

int looping;

void host_data_integrity();
void host_data_integrity_mem();
void initAMCC();
void host_fill_memory( );
int  host_validate_memory( );
void host_walking_bits();
void host_memory_short_test();
void host_mailbox_walking_bits();
void write_outgoing_mailbox();
void validate_incoming_mailbox();
void host_ramp_test();

int main()
{

unsigned read_u_val;       /* 2 bytes */
unsigned write_u_val;
char read_c_val;

unsigned long read_l_val;  /* 4 bytes */
unsigned long write_l_val;

/* ---------------------------------- */
/*      DSP register offsets          */
/* ---------------------------------- */

/* PCI Bus Operation Registers */

#define OMB1    0x00    /* outgoing mailbox register 1 */
#define OMB2    0x04    /* outgoing mailbox register 2 */
#define OMB3    0x08    /* outgoing mailbox register 3 */
#define OMB4    0x0c    /* outgoing mailbox register 4 */
#define IMB1    0x10    /* incoming mailbox register 1 */
#define IMB2    0x14    /* incoming mailbox register 2 */
#define IMB3    0x18    /* incoming mailbox register 3 */
#define IMB4    0x1c    /* incoming mailbox register 4 */
#define MBEF    0x34    /* mail-box empty/full status reg */

#define PCICMD  0x08
#define PCIADDR 0x04
#define PCIPAGE 0x00

/* ------------------------------------------------- */
/* general purpose variables, used for register test */
/* ------------------------------------------------- */

long ilong;

int test_number;
int bit_place;
int seed;
int fail;

char key;

initAMCC();

test_number = 1;

while (test_number != 0) {
  switch (test_number) {
    case 1:
	 /* ------ */
	 /*  Menu  */
	 /* ------ */
		printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
		printf(" 0 Exit\n");
		printf(" 1 Menu\n");
		printf(" 2 Memory(PCI) Walking 1's and 0's\n");
		printf(" 3 Write / Validate Memory(PCI) Test\n");
		printf(" 4 Full Memory(PCI) Test\n");
		printf(" 5 Memory(PCI) Loop\n");
		printf(" 6 OMB1 Write / Read Back\n");
		printf(" 7 Reserved\n");
		printf(" 8 Reserved\n");
		printf(" 9 Reserved\n");
		printf("10 Write OMB1 .. OMB4\n");
		printf("11 Validate IMB1 .. IMB4\n");
		printf("12 Write Memory(PCI)\n");
		printf("13 Write Full Memory(PCI)\n");
		printf("14 Validate Memory(PCI)\n");
		printf("15 Validate Full Memory(PCI)\n");
		printf("16 Data Integrity Using Mailbox\n");
		printf("17 Data Integrity Using Memory Location\n");
		printf("18 Data Integrity (TF) Using Mailbox\n");
		printf("19 Data Integrity (TF) Using Memory Location\n");
		printf("20 Ramp Test\n");

		printf("\nEnter test number to run >");
		scanf("%d",&test_number);
		scanf("%c",&key);
	break;

    case 2:
		printf("Memory(PCI) Walking 1's and 0's\n");
		host_walking_bits();
		test_number = 1;
    break;

    case 3:
		printf("Write / Validate Memory(PCI) Test\n");
		host_memory_short_test();
		test_number = 1;
    break;

    case 4:
		printf("Full Memory(PCI) Test\n");
		seed = 1;
		host_fill_memory(seed);
		if ( fail = host_validate_memory(seed) )
	 		printf ("test fails, number of failures = %d\n", fail);
		 else
	 		printf ("test passes\n");

		printf("type any key to continue\n");
		scanf("%c",&key);

		test_number = 1;
    break;

    case 5:
		printf("Memory(PCI) Loop\n");
		host_read_write_loop();
		test_number = 1;
    break;

    case 6:
		printf("OMB1 Write / Read Back\n");
		host_mailbox_walking_bits();
		test_number = 1;
    break;

    case 7:
		printf("Reserved\n");
		test_number = 1;
    break;

    case 8:
		printf("Reserved\n");
		test_number = 1;
    break;

    case 9:
		printf("Reserved\n");
		test_number = 1;
    break;

    case 10:
		printf("Write OMB1 .. OMB4\n");
		write_outgoing_mailbox();
		test_number = 1;
    break;

    case 11:
		printf("Validate IMB1 .. IMB4\n");
		validate_incoming_mailbox();
		test_number = 1;
    break;

    case 12:
		printf("Write Memory(PCI)\n");
		printf("type any key to continue, not implemented\n");
		scanf("%c",&key);

		test_number = 1;
    break;

    case 13:
		printf("Write Full Memory(PCI)\n");
		printf("type any key to continue, not implemented\n");
		scanf("%c",&key);
		test_number = 1;
    break;

    case 14:
		printf("Validate Memory(PCI)\n");
		printf("type any key to continue, not implemented\n");
		scanf("%c",&key);
		test_number = 1;
    break;

    case 15:
		printf("Validate Full Memory(PCI)\n");
		printf("type any key to continue, not implemented\n");
		scanf("%c",&key);
		test_number = 1;
    break;

    case 16:
		printf("Data Integrity Using Mailbox\n");
		host_data_integrity();
		test_number = 1;
    break;

    case 17:
		printf("Data Integrity Using Memory Location\n");
		host_data_integrity_mem();
		test_number = 1;
    break;

    case 18:
		printf("Data Integrity (TF) Using Mailbox\n");
		host_tf_test();
		test_number = 1;
    break;

    case 19:
		printf("Data Integrity (TF) Using Memory Location\n");
		host_tfmb_test();
		test_number = 1;
    break;

    case 20:
		printf("\nStart Ramp Test On Control Computer, then press enter to start");
		scanf("%c",&key);
		host_ramp_test();
		test_number = 1;
    break;

    }   /* switch */

 }  /* while */
}

void interrupt get_out(__CPPARGS) {
  looping = 0;             /* change global var to get out of oop */
}
